#include<Arpschuino.h>

#include <lib_dmx.h>
#define default_adress (1)//adresse DMX par defaut
#define    DMX512     (0) 
int nbre_circuits (16);
int address = default_adress;

uint8_t actual_level[16] = {0};

//////////////////////////PATCH////////////////////////////////////////////
byte output [16] = {Arp0,Arp1,Arp2,Arp3,Arp4,Arp5,Arp6,Arp7,Arp8,Arp9,Arp10,Arp11,Arp12,Arp13,Arp14,Arp15};
#define bascule 127  //la valeur où passer de LOW à HIGH
///////////////////////////////////////////////////////////////////////

unsigned long previousMillis = 0;
const long interval = 500; 

void setup(){

  pinMode(LED_BUILTIN, OUTPUT);
  
  Arp_arpdress_board();//prise en charge de l'arpdress board
  //à commenter pour une adresse fixe


    for(int i=0;i<nbre_circuits;i++)//met les 16 sorties en output
    {
     pinMode(output [i], OUTPUT); //initialisation en sortie
     digitalWrite(output [i], LOW);//initialisation relais ouvets    
    }

  digitalWrite(LED_BUILTIN,HIGH);

  DMX.attachRXInterrupt  (frame_received);
  DMX.set_control_pin(ArpDMXControl);    // Arduino output pin for MAX485 input/output control (connect to MAX485 pins 2-3) 
  DMX.set_rx_address(address);      // dmx start address
  DMX.set_rx_channels(nbre_circuits);     // number of rx channels
  DMX.init_rx(DMX512);        // starts universe 0 as rx


}

void loop()
{
   if(millis() - previousMillis >= interval)// une demi-seconde sans reception 
   {
      previousMillis = millis();   
      digitalWrite(LED_BUILTIN,  HIGH); // on éteind la led     
   }

   for(int i=0;i<nbre_circuits;i++)
   {
      if(DMX.RxBuffer[i] != actual_level[i])
      {
        if (ArduinoDmx0.RxBuffer[i]> bascule ){
         digitalWrite(output [i], HIGH);
         delay(200);
         digitalWrite(output [i], LOW);
          }
        else{
        digitalWrite(output [i], LOW);
         }  
       }
   }

 void frame_received(uint8_t universe) // cette boucle est executé à chaque réception d'une trame DMX
{
  Arp_led_temoin ();//la led clignote si elle reçoit un signal DMX
  previousMillis = millis();  
}
